<?php
// $Id: cmis_alfresco.pages.inc,v 1.2 2009/09/09 16:51:41 cbalan Exp $

/**
 * @file
 * Provides cmis_alfresco pages
 */

/**
 * Keyword based search
 * 
 * @param $keyword
 * @param $p
 */
function cmis_alfresco_opensearch_view($keyword = NULL, $p = 1) {
  module_load_include('utils.inc', 'cmis_alfresco');

  // Add opensearch form
  $contents = drupal_get_form('cmis_alfresco_opensearch_form', NULL);
  
  if ($keyword) {
    $result = cmis_alfresco_invoke_service('/api/search/keyword.atom?q='. urlencode($keyword) .'&p='. $p);
    if (false != $result) {

      // Process the returned XML
      $xml = cmis_alfresco_utils_get_CMIS_xml($result);
    
      // Set up results list
      $contents .= theme('cmis_alfresco_opensearch_results', $xml->xpath('//D:entry'));
      
      // Set up pager
      $opensearch = $xml->children(cmis_alfresco_utils_ns('opensearch'));
      $total_items = (int) $opensearch->totalResults;
      $items_per_page = (int) $opensearch->itemsPerPage;

      if (fmod($total_items, $items_per_page) == 0) {
        $last_page_number = floor($total_items / $items_per_page);
      } 
      else {
        $last_page_number = floor($total_items / $items_per_page) + 1;
      }

      // Add pagination bar
      $contents .= theme('cmis_alfresco_pager', 'cmis/opensearch/'. $keyword .'/', $last_page_number);
    } 
    else {
      $contents .= 'Error';
    }
  }

  return $contents;  
}